#!/usr/bin/lua
--[[
Általános mátrixriport. Paraméterek:
	- oszlopfej csv-file
	- sorfej csv-file
	- érték csv-file
Oszlopfej az oszlopfejléc szerint rendezett. A címke nélküli sor a sorfejléc értéke, es a file elso soraban van (ha elmarad, ures szoveg). Oszlopok:
	címke (pl. frakciónév)
	érték (amit ki kell írni a fejlécbe)
Sorfej a mátrix sorai szerint rendezett
	- címke (pl. vker száma)
	- érték, amit a sor első oszlopába ki kell írni (vker neve)
Érték:
	- sorcímke (pl. választókerület száma)
	- oszlopcímke (pl. frakciónév)
	- a kiírandó érték
A kimenet csvkonv.lua-val alakítható html-re vagy wiki-formára.
]]

require('strspn')

ofej = {}	-- oszlop sorszamok
oszam = 0	-- az oszlopok szama
for line in io.lines(arg[1]) do
        --print(line)
	sor  = {}
	strspn(line,sor,'	')
	if sor[1] == ''
	then	io.stdout:write(sor[2])
	else	io.stdout:write('	'..sor[2])
		oszam = oszam+1
		ofej[sor[1] ] = oszam
	end
end
print('')
--for key,value in pairs(ofej) do print(key,value) end

sfej = {}	-- sorcimkek
srend = {}	-- a cimkek sorrendje
for line in io.lines(arg[2]) do
        --print(line)
	sor  = {}
	strspn(line,sor,'	')
	sfej[sor[1] ] = sor[2]
	table.insert(srend,sor[1])
end
--for key,value in pairs(sfej) do print(key,value) end

matr = {}	-- matrix
for line in io.lines(arg[3]) do
        --print(line)
	sor  = {}
	strspn(line,sor,'	')
	if not matr[sor[1] ] then matr[sor[1] ] = {} end
	if not matr[sor[1] ][ofej[sor[2] ] ]		-- ha tobb ertek van egy kockaban, a vegere irjuk
	then	matr[sor[1] ][ofej[sor[2] ] ] = sor[3]
	else	matr[sor[1] ][ofej[sor[2] ] ] = matr[sor[1] ][ofej[sor[2] ] ]..'<p>'..sor[3]
	end
end

-- Most jon a lenyeg: a matrixkiiras
for line,vker in pairs(srend)
do	io.stdout:write(sfej[vker])
	for o=1,oszam
	do	if matr[vker] and matr[vker][o]
		then	io.stdout:write('	'..matr[vker][o])
		else	io.stdout:write('	')
		end
	end
	print('')
end
